#importing wx files
import wx

#import the newly created GUI file
import wfrelayGUI

#Device class
import BV4115W


#inherit from the MainFrame created in wxFormBuilder and create RlyFrame
class RlyFrame(wfrelayGUI.mainFrame):
	#constructor
	def __init__(self,parent):
	    #initialize parent class
		wfrelayGUI.mainFrame.__init__(self,parent)
		self.s = None
		self.connected = False
		self.tmr.period=10000
		try:
			with open('wifiinfo.txt') as f:
				data = f.readlines()
				f.close()
				self.txtIP.SetValue(data[0].replace('\n',''))
				self.txtPort.SetValue(data[1])
				self.lblRelayA.SetLabel(data[2])
				self.lblRelayB.SetLabel(data[3])
				self.lblRelayC.SetLabel(data[4])
				self.lblRelayD.SetLabel(data[5])
				self.lblRelayE.SetLabel(data[6])
				self.lblRelayF.SetLabel(data[7])
				self.lblRelayG.SetLabel(data[8])
				self.lblRelayH.SetLabel(data[9])
		except:
			print 'no config file'

	# connect to relay class
	def btnConnect(self,event):
		self.s = BV4115W.bv4115(self.txtIP.GetValue(),int(self.txtPort.GetValue()))
		if self.s.wfCheck() == True:
			self.connected = True
			self.lblConnectInfo.SetLabel('WF_CONNECTED')
			self.doRefresh()
			# check that the microcontroller is responding
			if self.s.devCmd('dD') <> '4115':
				self.lblConnectInfo.SetLabel('ERROR\r\nUse Reset ALL')
			else:	
				self.lblConnectInfo.SetLabel('CONNECTED\r\nReady')
		else:
			self.lblConnectInfo.SetLabel('Error No Connect')
			return

	# scale
	def rdoMs(self,event): # 1
		self.rdo1.SetValue(True)
		self.s.devCmd('dW9,1')
		self.s.devCmd('dW10,0')

	def rdoSec(self,event): # 1000
		self.rdo2.SetValue(True)
		self.s.devCmd('dW9,232')
		self.s.devCmd('dW10,3')

	def rdoMin(self,event): # 60000
		self.rdo3.SetValue(True)
		self.s.devCmd('dW9,96')
		self.s.devCmd('dW10,234')

	# relay A
	def btnRlyA(self,event):
		if  self.lblA.GetLabel() == 'ON':
			self.s.devCmd('da0,'+self.txtTimerA.GetValue())
		else:
			self.s.devCmd('da1,'+self.txtTimerA.GetValue())
			self.btnA.Enabled = False
		self.doRefresh()

	# relay B	
	def btnRlyB(self,event):
		if  self.lblB.GetLabel() == 'ON':
			self.s.devCmd('db0,'+self.txtTimerB.GetValue())
		else:
			self.s.devCmd('db1,'+self.txtTimerB.GetValue())
		self.doRefresh()

	# relay C
	def btnRlyC(self,event):
		if  self.lblC.GetLabel() == 'ON':
			self.s.devCmd('dc0,'+self.txtTimerC.GetValue())
		else:
			self.s.devCmd('dc1,'+self.txtTimerC.GetValue())
		self.doRefresh()

	# relay D
	def btnRlyD(self,event):
		if  self.lblD.GetLabel() == 'ON':
			self.s.devCmd('dd0,'+self.txtTimerD.GetValue())
		else:
			self.s.devCmd('dd1,'+self.txtTimerD.GetValue())
		self.doRefresh()

	# relay E
	def btnRlyE(self,event):
		if  self.lblE.GetLabel() == 'ON':
			self.s.devCmd('de0,'+self.txtTimerE.GetValue())
		else:
			self.s.devCmd('de1,'+self.txtTimerE.GetValue())
		self.doRefresh()

	# relay F
	def btnRlyF(self,event):
		if  self.lblF.GetLabel() == 'ON':
			self.s.devCmd('df0,'+self.txtTimerF.GetValue())
		else:
			self.s.devCmd('df1,'+self.txtTimerF.GetValue())
		self.doRefresh()

	# relay G
	def btnRlyG(self,event):
		if  self.lblG.GetLabel() == 'ON':
			self.s.devCmd('dg0,'+self.txtTimerG.GetValue())
		else:
			self.s.devCmd('dg1,'+self.txtTimerG.GetValue())
		self.doRefresh()

	# relay H
	def btnRlyH(self,event):
		if  self.lblH.GetLabel() == 'ON':
			self.s.devCmd('dh0,'+self.txtTimerH.GetValue())
		else:
			self.s.devCmd('dh1,'+self.txtTimerH.GetValue())
		self.doRefresh()

	# reset all device that will trun all relays off
	def btnReset(self,event):
		self.s.wfCmd('rr')

	# closes connection and also saves data
	def btnClose(self,event):
		#self.s.close()
		try:
			f = open('wifiinfo.txt','w')
			f.write(self.txtIP.GetValue()+'\n')
			f.write(self.txtPort.GetValue())
			f.write(self.lblRelayA.GetLabel())
			f.write(self.lblRelayB.GetLabel())
			f.write(self.lblRelayC.GetLabel())
			f.write(self.lblRelayD.GetLabel())
			f.write(self.lblRelayE.GetLabel())
			f.write(self.lblRelayF.GetLabel())
			f.write(self.lblRelayG.GetLabel())
			f.write(self.lblRelayH.GetLabel())
			f.close()
			self.Close()
		except:
			print 'no config file'


	# timer, called every second
	def tmrAction(self,event):
  		self.doRefresh();
  		#event.Skip()

	# -------------------- Utilities -------------------------------------------
	# refreshes all button status
	def doRefresh(self):
		if self.connected == False: return
		print 'start'
		stat = int(self.s.devCmd('di'))
		#print 'stat=',stat
		if (stat & 0x1): self.lblA.SetLabel('ON')
		else: self.lblA.SetLabel('OFF')
		if self.s.devCmd('dr1') == '0': self.btnA.Enabled = True
		else: self.btnA.Enabled = False

		if (stat & 0x2): self.lblB.SetLabel('ON')
		else: self.lblB.SetLabel('OFF')
		if self.s.devCmd('dr2') == '0': self.btnB.Enabled = True
		else: self.btnB.Enabled = False

		if (stat & 0x4): self.lblC.SetLabel('ON')
		else: self.lblC.SetLabel('OFF')
		if self.s.devCmd('dr3') == '0': self.btnC.Enabled = True
		else: self.btnC.Enabled = False

		if (stat & 0x8): self.lblD.SetLabel('ON')
		else: self.lblD.SetLabel('OFF')
		if self.s.devCmd('dr4') == '0': self.btnD.Enabled = True
		else: self.btnD.Enabled = False

		if (stat & 0x10): self.lblE.SetLabel('ON')
		else: self.lblE.SetLabel('OFF')
		if self.s.devCmd('dr5') == '0': self.btnE.Enabled = True
		else: self.btnE.Enabled = False

		if (stat & 0x20): self.lblF.SetLabel('ON')
		else: self.lblF.SetLabel('OFF')
		if self.s.devCmd('dr6') == '0': self.btnF.Enabled = True
		else: self.btnF.Enabled = False

		if (stat & 0x40): self.lblG.SetLabel('ON')
		else: self.lblG.SetLabel('OFF')
		if self.s.devCmd('dr7') == '0': self.btnG.Enabled = True
		else: self.btnG.Enabled = False

		if (stat & 0x80): self.lblH.SetLabel('ON')
		else: self.lblH.SetLabel('OFF')
		if self.s.devCmd('dr8') == '0': self.btnH.Enabled = True
		else: self.btnH.Enabled = False

		# scale
		scale = int(self.s.devCmd('dR10'))*256
		scale += int(self.s.devCmd('dR9'))
		print scale
		if scale == 1:
			self.lblAction.SetLabel('Action in mS')
			self.rdo1.SetValue(True)
		if scale == 1000:
			self.lblAction.SetLabel('Action in Sec')
			self.rdo2.SetValue(True)
		if scale == 60000:
			self.lblAction.SetLabel('Action in min')
			self.rdo2.SetValue(True)
		print 'end'


#mandatory in wx, create an app, False stands for not deteriction stdin/stdout
#refer manual for details
app = wx.App(False)

#create an object of CalcFrame
frame = RlyFrame(None)
#show the frame
frame.Show(True)
#start the applications
app.MainLoop()
